一.新建一个word,选中视图--工具栏--窗体,点击文字型窗体域添加一个域。双击新添加的域,默认文字填写你要显示的文字,域设置--书签填入一个标签名(book1),用于在程序中识别这个域  二.添加COM引用---Microsoft  Word  11.0  Object Library
  三 .添加命名空间---using Microsoft.Office.Interop.Word;
我已打开文档,并用oDoc.Activate();   激活了文档..object lableName = "book1";  //book1是在word中我添加的一个文字型窗体域的标签名 //调试时在下面这句出错:Object reference not set to an instance of an object.
  
Book bm = doc.Books.get_Item(ref lableName);//返回标签     这句出错,请问是什么原因?
  
bm.Range.Text = parFillName;//设置域标签的内容   我是按这里的方法:http://blog.csdn.net/A1027/archive/2008/06/11/2536557.aspx#
谢谢大家...    

解决方案 »

  1.   


    c#读取word内容,c#写入word内容,C#操作word
    2008年05月29日 星期四 11:23
           一个项目报表相对比较简单,所以报表打印采用VBA引擎,通过定制Word模版,然后根据模版需要填充数据,然后OK,打印即可。实现方法:首先需要引用VBA组建,我用的是Office2003 Professional,Dll版本号为Microsoft Word11.0,另外当然还需要引用Interop.Word.Dll.代码如下:#region 打开Word文档,并且返回对象wDoc,wDoc
    /// <summary>
    /// 打开Word文档,并且返回对象wDoc,wDoc
    /// </summary>
    /// <param name="FileName">完整Word文件路径+名称</param> 
    /// <param name="wDoc">返回的Word.Document wDoc对象</param>
    /// <param name="WApp">返回的Word.Application对象</param>
    public static void CreateWordDocument(string FileName,ref Word.Document wDoc,ref Word.Application WApp)
    {
       if(FileName == "") return;
       Word.Document thisDocument = null;
       Word.FormFields   formFields = null;
       Word.Application thisApplication = new Word.ApplicationClass();
       thisApplication.Visible = true;
       thisApplication.Caption = "";
       thisApplication.Options.CheckSpellingAsYouType = false;
       thisApplication.Options.CheckGrammarAsYouType = false;   Object filename = FileName;
       Object ConfirmConversions = false;
       Object ReadOnly = true;
       Object AddToRecentFiles = false;   Object PasswordDocument = System.Type.Missing;
       Object PasswordTemplate = System.Type.Missing;
       Object Revert = System.Type.Missing;
       Object WritePasswordDocument = System.Type.Missing;
       Object WritePasswordTemplate = System.Type.Missing;
       Object Format = System.Type.Missing;
       Object Encoding = System.Type.Missing;
       Object Visible = System.Type.Missing;
       Object OpenAndRepair = System.Type.Missing;
       Object DocumentDirection = System.Type.Missing;
       Object NoEncodingDialog = System.Type.Missing;
       Object XMLTransform = System.Type.Missing;   try
       {
        Word.Document wordDoc =
         thisApplication.Documents.Open(ref filename, ref ConfirmConversions,
         ref ReadOnly, ref AddToRecentFiles, ref PasswordDocument, ref PasswordTemplate,
         ref Revert,ref WritePasswordDocument, ref WritePasswordTemplate, ref Format,
         ref Encoding, ref Visible, ref OpenAndRepair, ref DocumentDirection,
         ref NoEncodingDialog, ref XMLTransform );
        
        thisDocument = wordDoc;
        wDoc = wordDoc;
        WApp = thisApplication;
        formFields = wordDoc.FormFields;
       }
       catch(Exception ex)
       {
        MessageBox.Show(ex.Message);
       }
       
    }
    #endregion
    调用上面静态方法,打开目标文件并且把DataGrid中数据填充到对应Word标签中去
    #region Word填充数据(For Example)
    /// <summary>
    /// Word填充数据
    /// </summary>
    private void WordLoadData()
    {
       Word.Document wDoc=null;
       Word.Application wApp=null;
       sysFun.CreateWordDocument("E:\\监测报告(new).dot",ref wDoc,ref wApp);   //对标签"C"进行填充
       object bkmC="C";
       if(wApp.ActiveDocument.Books.Exists("C") == true)
       {
        wApp.ActiveDocument.Books.get_Item
         (ref bkmC).Select();
       }
       wApp.Selection.TypeText(this.txt1.Text);
       object bkmG = "TWaterTable3";
       object unit; 
       object count; //移动数
       object extend; 
          extend = Word.WdMovementType.wdExtend;
       unit = Word.WdUnits.wdCell;
       //把DataGrid中数据填充到标签TWaterTable3上
       if(wApp.ActiveDocument.Books.Exists("TWaterTable3") == true)
       {
        wApp.ActiveDocument.Books.get_Item
         (ref bkmG).Select();    for(int i=0;i<this.gridEX1.RecordCount;i++)
        {
         if(i==0)
         {
          count=1;
         }
         else
         {
          count=0;
         }
         //需填充5列数据
         wApp.Selection.Move(ref unit,ref count);
         wApp.Selection.TypeText(gridEX1.GetRow(i).Cells[0].Text);
         count=1;
          
         wApp.Selection.Move(ref unit,ref count);
         wApp.Selection.TypeText(gridEX1.GetRow(i).Cells[1].Text);
          
         wApp.Selection.Move(ref unit,ref count);
         wApp.Selection.TypeText(gridEX1.GetRow(i).Cells[2].Text);
          
         wApp.Selection.Move(ref unit,ref count);
         wApp.Selection.TypeText(gridEX1.GetRow(i).Cells[3].Text);
         
         wApp.Selection.Move(ref unit,ref count);
         wApp.Selection.TypeText(gridEX1.GetRow(i).Cells[4].Text);
         //换行
         wApp.Selection.MoveRight(ref unit,ref count,ref extend);
        }
       }
    }
    #endregion我们必须使用Word.ApplicationClass来存取一个Word应用程序。 
    在内存中打开一个Word文档,将所有的内容复制到剪贴板中,这样我们就可以从剪贴板中取得数据。 
    需要的代码如下: 
    Word.ApplicationClass wordApp = new ApplicationClass(); object file = path; object nullobj = System.Reflection.Missing.Value; Word.Document doc = wordApp.Documents.Open( ref file, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj, ref nullobj); doc.ActiveWindow.Selection.WholeStory(); doc.ActiveWindow.Selection.Copy(); IDataObject data = Clipboard.GetDataObject(); txtFileContent.Text = data.GetData(DataFormats.Text).ToString(); doc.Close();
      

  2.   

    http://www.cnblogs.com/izhouwei/articles/659830.html
      

  3.   

    谢谢大家...可是我给出的那点代码有什么问题吗?一定要用vba吗?一楼给出的代码那么多,说实话我都看不懂...一楼的代码能不能简化一下啊,非常感激...我已经打开了work文档,不是直接在work设好域就可以对这个域进行写入了吗?
    为什么我的代码编译没错,而调试会出现那些信息啊...麻烦大家一下了,谢谢..我现在去www.cnblogs.com看看
      

  4.   


    这有点太神了吧,呵呵...如果是C++或算法或OS之类的,10s怎么可能啊..还请大大耐心一点,帮我看下啦...